<template>
    <app-layout @click="selectedId = -1">
        <template #header>File Manager</template>
        <panel @drop.prevent="dropFile" @dragover.prevent="dragover = true" @dragleave="dragover=false">
            <template #breadcrumbs>
                <inertia-link :href="'/files/' + userId" class="text-blue-500 font-bold" v-if="username && username != $page.user.name">{{username}}'s Files</inertia-link>
                <inertia-link href="/files" class="text-blue-500 font-bold" v-else>My Files</inertia-link>
                <div v-for="(item,i) in breadcrumb" :key="i">
                    <span class="mx-2">/</span>
                    <inertia-link href="#" class="text-blue-500 font-bold" v-if="i == breadcrumb.length">{{item}}</inertia-link>
                    <span v-else>{{item}}</span>
                </div>
            </template>
            <div v-if="hasPermission(['read-everything','group:read-everything','group:read-files'])">
                Can access others
            </div>
            <template #header>
                <label class="bg-green-500 hover:bg-green-600 rounded py-1 px-2 " @click.stop="">
                    <feather type="upload" class="h-4" /> Upload
                    <input type="file" class="hidden" multiple @change="uploadFile" accept=".tar,.zip,.bmp,.gif,.jpeg,.jpg,.png,.svg,.tiff,.ico,.mp4,.webm,.ogv,.html,.pdf" />
                </label>
                <inertia-link class="bg-blue-500 hover:bg-blue-600 rounded py-1 px-2 ml-2" @click.stop="" :href="sortedFiles[selectedId].url" v-if="selectedId >= 0 && !sortedFiles[selectedId].format.startsWith('text')">
                    <feather type="download" class="h-4" /> Open
                </inertia-link>
                <button class="bg-blue-500 hover:bg-blue-600 rounded py-1 px-2 ml-2" @click.stop="" v-if="selectedId >= 0 && sortedFiles[selectedId].format.startsWith('text')">
                    <feather type="edit" class="h-4" /> Edit
                </button>
                <label class="bg-orange-500 hover:bg-orange-600 rounded py-1 px-2 ml-2" @click.stop="" v-if="selectedId >= 0">
                    <feather type="repeat" class="h-4" /> Replace
                    <input type="file" class="hidden" />
                </label>
                <!-- TODO: Rename File/Folder -->
                <button class="bg-red-500 hover:bg-red-600 rounded py-1 px-2 ml-2" @click.stop=""  v-if="selectedId >= 0">
                    <feather type="trash-2" class="h-4" />
                    Delete
                </button>
            </template>
            <div :class="{'border-red-600':dragover}">
                <div v-if="uploadFilename != ''" class="w-full bg-gray-500 mb-3">
                    <div class="h-5 bg-green-600 px-3 text-sm text-white whitespace-no-wrap" :style="{'width':uploadProgress+'%'}">
                        Uploading {{ uploadFilename }} ... {{ uploadProgress }}%
                    </div>
                </div>
                <div class="py-2 px-4" v-if="files.length < 1">You have no files in this folder.</div>
                <table class="block bg-gray-100 dark:bg-gray-800 table-auto rounded-b-lg" v-if="display == 1 && files.length > 0">
                    <thead>
                        <tr class="bg-gray-400 w-full">
                            <th v-for="(column,columnKey) in columns" :key="columnKey" class="px-4 py-2 border hover:bg-gray-500 transition-colors duration-300 ease-in-out" :class="column.class"  @click="column.nosort||sortBy(columnKey)">
                                {{column.title}}
                                <feather class="h-3" type='chevron-down' v-if="currentSort==columnKey && currentSortDir == 1" />
                                <feather class="h-3"  type='chevron-up' v-if="currentSort==columnKey && currentSortDir == -1" />
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr 
                            v-for="(file, index) in sortedFiles"
                            class="transition-colors duration-300 ease-in-out"
                            :class="{'bg-yellow-200 dark:hover:bg-yellow-600':selectedId==index,'hover:bg-yellow-100 dark:hover:bg-yellow-500':selectedId!=index,'bg-gray-200 dark:bg-gray-600':index%2==1}" 
                            :key="index" 
                            @click.stop="(file.format == 'folder')?goto(file.url):selectedId = index"
                            @dblclick="goto(file.url)">
                            <td class="px-4 py-2 border">
                                <feather class="pt-1" v-if="file.format == 'application/zip'" type="archive" /><!-- this should never happen -->
                                <feather class="pt-1" v-else-if="file.format == 'folder'" type="folder" />
                                <feather class="pt-1" v-else-if="file.format == 'text/html'" type="globe" />
                                <feather class="pt-1" v-else-if="file.format.startsWith('text')" type="file-text" />
                                <feather class="pt-1" v-else-if="file.format.startsWith('image')" type="image" />
                                <feather class="pt-1" v-else-if="file.format.startsWith('video')" type="video" />
                                <feather class="pt-1" v-else type="file" />
                            </td>
                            <td class="px-4 py-2 border">{{file.name}}</td>
                            <td class="px-4 py-2 border">{{(file.modified)?file.modified.format('lll'):"None"  }}</td>
                            <td class="px-4 py-2 border">{{(file.format == 'folder')? "N/A":file.nicesize}}</td>
                        </tr>
                    </tbody>
                    <tfoot>
                        <tr>
                            <td :colspan="Object.keys(columns).length" class="text-center py-2">
                                <feather type="chevrons-left" class="cursor-pointer hover:text-blue-800 dark:hover:text-blue-300 h-4 pt-1" @click="currentPage = 1" />
                                <feather type="chevron-left" class="cursor-pointer hover:text-blue-800 dark:hover:text-blue-300 h-4 pt-1" @click="prevPage()" />
                                <a v-for="pagenum in pageNums" :key="pagenum" 
                                    :class="{'font-bold cursor-default dark:text-gray-400':pagenum == currentPage,'cursor-pointer hover:text-blue-800 dark:hover:text-blue-300': pagenum != currentPage}"
                                    @click="currentPage = pagenum">
                                    {{pagenum}}
                                </a>
                                <feather type="chevron-right" class="cursor-pointer hover:text-blue-800 dark:hover:text-blue-300 h-4 pt-1" @click="nextPage()" />
                                <feather type="chevrons-right" class="cursor-pointer hover:text-blue-800 dark:hover:text-blue-300 h-4 pt-1 mr-4" @click="currentPage = Math.ceil(this.files.length / this.pageSize)" />
                                <select v-model="pageSize" class="bg-white dark:bg-black rounded">
                                    <option value="10">10</option>
                                    <option value="20">20</option>
                                    <option value="25">25</option>
                                    <option value="50">50</option>
                                </select>
                            </td>
                        </tr>
                    </tfoot>
                </table>
                <!-- TODO: Thumbnail Display -->
                <div v-if="display == 2 && files.length > 0">This is an incomplete thumbnail display.</div>
                <!-- TODO: Loading/Sorting overlay -->
                <div v-if="sorting">Sorting...</div>
            </div>
        </panel>
    </app-layout>
</template>

<script>
    import Vue from 'vue'
    import _ from 'lodash'
    import dayjs from 'dayjs'
    import filesize from 'filesize'
    import LocalizedFormat from 'dayjs/plugin/localizedFormat'
    dayjs.extend(LocalizedFormat)
    

    export default {
        props: {
            files: Array,
            path: String,
            username: String,
        },
        data(){
            const breadcrumb = this.path.split('/');
            const userId = breadcrumb.shift();
            return {
                selectedId: -1,
                dragover: false,
                breadcrumb,
                currentSort: 'none',
                currentSortDir: '',
                sorting: false,
                pageSize: 10,
                currentPage: 1,
                userId,
                uploadPromise: null,
                columns: {
                    type: {
                        nosort: true,
                        title: '',
                        class: "",
                        render: "feather",
                    },
                    name: {
                        title: 'File Name',
                        class: "w-8/12",
                    },
                    modified: {
                        title: "Last Modified",
                        class: "w-2/12"
                    },
                    size: {
                        title: "Size",
                        class: "w-2/12",
                    }
                },
                display: 1, // 1 = table, 2 = icons
                uploadProgress: 0,
                uploadFilename: "",
            }
        },
        mounted(){
            this.sortBy('none');
            this.files.forEach((file)=>{
                file.modified = dayjs.unix(file.updated_at);
                file.nicesize = filesize(Number(file.size));
            });
        },
        computed:{
            sortedFiles() {
                this.sorting = true;
                const ret = this.files.sort((a,b)=> {
                    // No sort
                    if(this.currentSort === 'none') return 0;
                    // Folders go to top alphabetically for size sort
                    if(this.currentSort === 'size' && a.format == 'folder') {
                        if(b.format == 'folder'){
                            if(a.name < b.name) return -1 * this.currentSortDir;
                            if(a.name > b.name) return 1 * this.currentSortDir;
                        }
                        return -1;
                    }
                    if(this.currentSort === 'size' && b.format == 'folder') {
                        if(a.format == 'folder'){
                            if(a.name < b.name) return -1 * this.currentSortDir;
                            if(a.name > b.name) return 1 * this.currentSortDir;
                        }
                        return 1;
                    }
                    // Rest of sorts
                    if(this.currentSort == 'modified') {
                        if(a[this.currentSort].unix() < b[this.currentSort].unix()) return -1 * this.currentSortDir;
                        if(a[this.currentSort].unix() > b[this.currentSort].unix()) return 1 * this.currentSortDir;
                    } else if(typeof a[this.currentSort] === 'string') {
                        if(a[this.currentSort].toLowerCase() < b[this.currentSort].toLowerCase()) return -1 * this.currentSortDir;
                        if(a[this.currentSort].toLowerCase() > b[this.currentSort].toLowerCase()) return 1 * this.currentSortDir;
                    } else {
                        if(a[this.currentSort] < b[this.currentSort]) return -1 * this.currentSortDir;
                        if(a[this.currentSort] > b[this.currentSort]) return 1 * this.currentSortDir;
                    }
                    return 0;
                }).filter((row, index) => {
                    let start = (this.currentPage-1)*this.pageSize;
                    let end = this.currentPage*this.pageSize;
                    if(index >= start && index < end) return true;
                });
                this.sorting = false;
                return ret;
            },
            pageNums(){
                // Warn: This is not easily scalable
                const pages = Math.ceil(this.files.length / this.pageSize);
                if(pages == 1) return [1];
                if(pages == 2) return [1,2];
                if(pages == 3) return [1,2,3];
                if(this.currentPage == 1) { // BEGIN
                    return [this.currentPage, this.currentPage + 1, this.currentPage + 2];
                } else if(this.currentPage == pages) { // END
                    return [this.currentPage - 2, this.currentPage - 1, this.currentPage];
                } else {
                    return [this.currentPage - 1, this.currentPage, this.currentPage + 1]
                }
            },
        },
        methods: {
            sortBy(column){
                
                // Set the variables first
                if(column != this.currentSort){
                    this.currentSort = column;
                    this.currentSortDir = 1;
                } else {
                    if(this.currentSortDir > 0) {
                        this.currentSortDir = -1;
                    } else {
                        this.currentSortDir = 1;
                    }
                }
            },
            nextPage:function() {
                if((this.currentPage*this.pageSize) < this.files.length) {
                    this.currentPage++;
                }
            },
            prevPage:function() {
                if(this.currentPage > 1) {
                    this.currentPage--;
                }
            },
            beginUpload(files){
                for(let i = 0; i < files.length; i++){
                    let file = files[i];
                    if(this.uploadPromise === null) this.uploadPromise = this.upload(file);
                    this.uploadPromise = this.uploadPromise.then(()=>this.upload(file));
                }
            },
            uploadFile(evt){
                this.beginUpload(evt.target.files)
            },
            upload(file){
                return new Promise((resolve,reject)=>{
                    const data = new FormData();
                    data.append('file',file);
                    this.$inertia.post('/files/' + this.path, data, {
                        preserveState: true,
                        preserveScroll: true,
                        onStart: () => {
                            this.uploadFilename = file.name;
                            this.uploadProgress = 0;
                        },
                        onProgress: progress => {
                            this.uploadProgress = Math.round((progress.loaded / progress.total) * 100);
                        },
                        onSuccess: page => {
                            this.uploadFilename = '';
                            resolve();
                        },
                        onCancel: reject,
                        only: ['files'],
                    });
                });
            },
            dropFile(evt){
                this.dragover=false;
                let files = evt.dataTransfer.files;
                if(!files) return;
                this.beginUpload(files);
            },
            goto(url){
                this.$inertia.get(url);
            },
        }
    }
</script>
